package com.company.testiobex.view.test;


import com.company.testiobex.view.main.MainView;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.router.Route;
import io.jmix.dynattrflowui.utils.DataProviderUtils;
import io.jmix.flowui.UiComponents;
import io.jmix.flowui.component.combobox.JmixComboBox;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.IntStream;

import static java.util.stream.Collectors.toMap;

@Route(value = "test", layout = MainView.class)
@ViewController("tdattd_Test")
@ViewDescriptor("test.xml")
public class Test extends StandardView {
	@Autowired
	private UiComponents uiComponents;
	@ViewComponent
	private VerticalLayout box;

	@Subscribe
	public void onInit(final InitEvent event) {
		box.add(create());
	}
	private JmixComboBox<Integer> create() {
		JmixComboBox<Integer> jmixComboBox = uiComponents.create(JmixComboBox.class);
		Map<Integer, String> options = IntStream.range(0, 100)
				.boxed()
				.collect(toMap(Function.identity(), i -> Integer.toString(i)));
		jmixComboBox.setItemLabelGenerator(options::get);
		jmixComboBox.setItems(DataProviderUtils.createCallbackDataProvider(new ArrayList<>(options.keySet())));
		return jmixComboBox;
	}
}